/**
 * @brief Enduro/X internal UBF field table
 *
 * @file Exfields.h
 */
/* -----------------------------------------------------------------------------
 * Enduro/X Middleware Platform for Distributed Transaction Processing
 * Copyright (C) 2009-2016, ATR Baltic, Ltd. All Rights Reserved.
 * Copyright (C) 2017-2019, Mavimax, Ltd. All Rights Reserved.
 * This software is released under one of the following licenses:
 * AGPL (with Java and Go exceptions) or Mavimax's license for commercial use.
 * See LICENSE file for full text.
 * -----------------------------------------------------------------------------
 * AGPL license:
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License, version 3 as published
 * by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU Affero General Public License, version 3
 * for more details.
 *
 * You should have received a copy of the GNU Affero General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * -----------------------------------------------------------------------------
 * A commercial use license is available from Mavimax, Ltd
 * contact@mavimax.com
 * -----------------------------------------------------------------------------
 */
public final class Exfields
{
	  /** number: 101 type: string*/
	  public final static int SRVCNM = 167772261;
	  /** number: 104 type: long*/
	  public final static int EV_FLAGS = 33554536;
	  /** number: 105 type: string*/
	  public final static int EV_MASK = 167772265;
	  /** number: 106 type: string*/
	  public final static int EV_FILTER = 167772266;
	  /** number: 107 type: string*/
	  public final static int EV_SRVCNM = 167772267;
	  /** number: 108 type: long*/
	  public final static int EV_SUBSNR = 33554540;
	  /** number: 115 type: long*/
	  public final static int EXDM_RESTARTS = 33554547;
	  /** number: 120 type: char*/
	  public final static int TMCMD = 67108984;
	  /** number: 121 type: string*/
	  public final static int TMXID = 167772281;
	  /** number: 123 type: short*/
	  public final static int TMRMID = 123;
	  /** number: 122 type: short*/
	  public final static int TMNODEID = 122;
	  /** number: 124 type: short*/
	  public final static int TMSRVID = 124;
	  /** number: 125 type: string*/
	  public final static int TMKNOWNRMS = 167772285;
	  /** number: 130 type: short*/
	  public final static int TMERR_CODE = 130;
	  /** number: 131 type: short*/
	  public final static int TMERR_REASON = 131;
	  /** number: 132 type: string*/
	  public final static int TMERR_MSG = 167772292;
	  /** number: 150 type: string*/
	  public final static int TMPROCESSID = 167772310;
	  /** number: 151 type: short*/
	  public final static int TMCALLERRM = 151;
	  /** number: 152 type: long*/
	  public final static int TMTXTOUT = 33554584;
	  /** number: 153 type: long*/
	  public final static int TMTXTOUT_LEFT = 33554585;
	  /** number: 154 type: short*/
	  public final static int TMTXSTAGE = 154;
	  /** number: 155 type: short*/
	  public final static int TMTXRMID = 155;
	  /** number: 156 type: char*/
	  public final static int TMTXRMSTATUS = 67109020;
	  /** number: 157 type: long*/
	  public final static int TMTXRMERRCODE = 33554589;
	  /** number: 158 type: short*/
	  public final static int TMTXRMREASON = 158;
	  /** number: 159 type: long*/
	  public final static int TMTXTRYCNT = 33554591;
	  /** number: 160 type: long*/
	  public final static int TMTXTRYMAXCNT = 33554592;
	  /** number: 161 type: long*/
	  public final static int TMTXFLAGS = 33554593;
	  /** number: 162 type: long*/
	  public final static int TMTXBTID = 33554594;
	  /** number: 200 type: string*/
	  public final static int EX_CPMCOMMAND = 167772360;
	  /** number: 201 type: string*/
	  public final static int EX_CPMOUTPUT = 167772361;
	  /** number: 202 type: string*/
	  public final static int EX_CPMTAG = 167772362;
	  /** number: 203 type: string*/
	  public final static int EX_CPMSUBSECT = 167772363;
	  /** number: 204 type: long*/
	  public final static int EX_CPMWAIT = 33554636;
	  /** number: 250 type: string*/
	  public final static int EX_CLTID = 167772410;
	  /** number: 251 type: carray*/
	  public final static int EX_DATA = 201326843;
	  /** number: 252 type: short*/
	  public final static int EX_DATA_BUFTYP = 252;
	  /** number: 253 type: string*/
	  public final static int EX_TSTAMP1_STR = 167772413;
	  /** number: 254 type: string*/
	  public final static int EX_TSTAMP2_STR = 167772414;
	  /** number: 255 type: string*/
	  public final static int EX_DATA_STR = 167772415;
	  /** number: 300 type: string*/
	  public final static int EX_QSPACE = 167772460;
	  /** number: 301 type: string*/
	  public final static int EX_QNAME = 167772461;
	  /** number: 302 type: long*/
	  public final static int EX_QFLAGS = 33554734;
	  /** number: 303 type: long*/
	  public final static int EX_QDEQ_TIME = 33554735;
	  /** number: 304 type: long*/
	  public final static int EX_QPRIORITY = 33554736;
	  /** number: 305 type: long*/
	  public final static int EX_QDIAGNOSTIC = 33554737;
	  /** number: 306 type: carray*/
	  public final static int EX_QMSGID = 201326898;
	  /** number: 307 type: carray*/
	  public final static int EX_QCORRID = 201326899;
	  /** number: 308 type: string*/
	  public final static int EX_QREPLYQUEUE = 167772468;
	  /** number: 309 type: string*/
	  public final static int EX_QFAILUREQUEUE = 167772469;
	  /** number: 310 type: long*/
	  public final static int EX_QURCODE = 33554742;
	  /** number: 311 type: long*/
	  public final static int EX_QAPPKEY = 33554743;
	  /** number: 312 type: long*/
	  public final static int EX_QDELIVERY_QOS = 33554744;
	  /** number: 313 type: long*/
	  public final static int EX_QREPLY_QOS = 33554745;
	  /** number: 314 type: long*/
	  public final static int EX_QEXP_TIME = 33554746;
	  /** number: 315 type: char*/
	  public final static int EX_QCMD = 67109179;
	  /** number: 316 type: string*/
	  public final static int EX_QDIAGMSG = 167772476;
	  /** number: 317 type: long*/
	  public final static int EX_QNUMMSG = 33554749;
	  /** number: 318 type: long*/
	  public final static int EX_QNUMLOCKED = 33554750;
	  /** number: 319 type: long*/
	  public final static int EX_QNUMSUCCEED = 33554751;
	  /** number: 320 type: long*/
	  public final static int EX_QNUMFAIL = 33554752;
	  /** number: 321 type: string*/
	  public final static int EX_QSTRFLAGS = 167772481;
	  /** number: 322 type: long*/
	  public final static int EX_QMSGTRIES = 33554754;
	  /** number: 323 type: short*/
	  public final static int EX_QMSGLOCKED = 323;
	  /** number: 324 type: string*/
	  public final static int EX_QMSGIDSTR = 167772484;
	  /** number: 325 type: long*/
	  public final static int EX_QNUMENQ = 33554757;
	  /** number: 326 type: long*/
	  public final static int EX_QNUMDEQ = 33554758;
	  /** number: 400 type: short*/
	  public final static int EX_NERROR_CODE = 400;
	  /** number: 401 type: string*/
	  public final static int EX_NERROR_MSG = 167772561;
	  /** number: 402 type: string*/
	  public final static int EX_NREQLOGFILE = 167772562;
	  /** number: 450 type: long*/
	  public final static int EX_TPERRNO = 33554882;
	  /** number: 451 type: long*/
	  public final static int EX_TPURCODE = 33554883;
	  /** number: 452 type: string*/
	  public final static int EX_TPSTRERROR = 167772612;
	  /** number: 500 type: char*/
	  public final static int EX_CC_CMD = 67109364;
	  /** number: 501 type: string*/
	  public final static int EX_CC_RESOURCE = 167772661;
	  /** number: 502 type: string*/
	  public final static int EX_CC_LOOKUPSECTION = 167772662;
	  /** number: 503 type: string*/
	  public final static int EX_CC_SECTIONMASK = 167772663;
	  /** number: 504 type: string*/
	  public final static int EX_CC_MANDATORY = 167772664;
	  /** number: 505 type: string*/
	  public final static int EX_CC_FORMAT_KEY = 167772665;
	  /** number: 506 type: string*/
	  public final static int EX_CC_FORMAT_FORMAT = 167772666;
	  /** number: 509 type: string*/
	  public final static int EX_CC_SECTION = 167772669;
	  /** number: 510 type: string*/
	  public final static int EX_CC_KEY = 167772670;
	  /** number: 511 type: string*/
	  public final static int EX_CC_VALUE = 167772671;
	  /** number: 600 type: short*/
	  public final static int EX_IF_ECODE = 600;
	  /** number: 601 type: string*/
	  public final static int EX_IF_EMSG = 167772761;
	  /** number: 602 type: string*/
	  public final static int EX_IF_URL = 167772762;
	  /** number: 603 type: string*/
	  public final static int EX_IF_REQHN = 167772763;
	  /** number: 604 type: string*/
	  public final static int EX_IF_REQHV = 167772764;
	  /** number: 605 type: string*/
	  public final static int EX_IF_REQCN = 167772765;
	  /** number: 606 type: string*/
	  public final static int EX_IF_REQCV = 167772766;
	  /** number: 607 type: string*/
	  public final static int EX_IF_RSPHN = 167772767;
	  /** number: 608 type: string*/
	  public final static int EX_IF_RSPHV = 167772768;
	  /** number: 609 type: string*/
	  public final static int EX_IF_RSPCN = 167772769;
	  /** number: 610 type: string*/
	  public final static int EX_IF_RSPCV = 167772770;
	  /** number: 611 type: string*/
	  public final static int EX_IF_RSPCPATH = 167772771;
	  /** number: 612 type: string*/
	  public final static int EX_IF_RSPCDOMAIN = 167772772;
	  /** number: 613 type: string*/
	  public final static int EX_IF_RSPCEXPIRES = 167772773;
	  /** number: 614 type: string*/
	  public final static int EX_IF_RSPCMAXAGE = 167772774;
	  /** number: 615 type: string*/
	  public final static int EX_IF_RSPCSECURE = 167772775;
	  /** number: 616 type: string*/
	  public final static int EX_IF_RSPCHTTPONLY = 167772776;
	  /** number: 620 type: string*/
	  public final static int EX_IF_REQFORMN = 167772780;
	  /** number: 621 type: string*/
	  public final static int EX_IF_REQFORMV = 167772781;
	  /** number: 622 type: string*/
	  public final static int EX_IF_REQQUERYN = 167772782;
	  /** number: 623 type: string*/
	  public final static int EX_IF_REQQUERYV = 167772783;
	  /** number: 630 type: long*/
	  public final static int EX_IF_URCODE = 33555062;
	  /** number: 631 type: carray*/
	  public final static int EX_IF_REQDATA = 201327223;
	  /** number: 632 type: carray*/
	  public final static int EX_IF_RSPDATA = 201327224;
	  /** number: 640 type: string*/
	  public final static int EX_IF_METHOD = 167772800;
	  /** number: 650 type: carray*/
	  public final static int EX_NETDATA = 201327242;
	  /** number: 651 type: string*/
	  public final static int EX_NETGATEWAY = 167772811;
	  /** number: 652 type: long*/
	  public final static int EX_NETCONNID = 33555084;
	  /** number: 653 type: string*/
	  public final static int EX_NETCORR = 167772813;
	  /** number: 654 type: string*/
	  public final static int EX_NETFLAGS = 167772814;
	  /** number: 655 type: long*/
	  public final static int EX_NETCONNIDCOMP = 33555087;
	  /** number: 656 type: string*/
	  public final static int EX_NETOURIP = 167772816;
	  /** number: 657 type: long*/
	  public final static int EX_NETOURPORT = 33555089;
	  /** number: 658 type: string*/
	  public final static int EX_NETTHEIRIP = 167772818;
	  /** number: 659 type: long*/
	  public final static int EX_NETTHEIRPORT = 33555091;
	  /** number: 660 type: char*/
	  public final static int EX_NETCONMODE = 67109524;
	  /** number: 751 type: long*/
	  public final static int EX_NETRCODE = 33555183;
	  /** number: 700 type: string*/
	  public final static int EX_VIEW_NAME = 167772860;
	  /** number: 701 type: long*/
	  public final static int EX_VIEW_CKSUM = 33555133;
	  /** number: 702 type: string*/
	  public final static int EX_VIEW_INCLFLDS = 167772862;
	  /** number: 750 type: string*/
	  public final static int EX_CACHE_DBNAME = 167772910;
	  /** number: 751 type: string*/
	  public final static int EX_CACHE_OPEXPR = 167772911;
	  /** number: 752 type: short*/
	  public final static int EX_CACHE_BUFTYP = 752;
	  /** number: 753 type: carray*/
	  public final static int EX_CACHE_DUMP = 201327345;
	  /** number: 754 type: long*/
	  public final static int EX_CACHE_TPERRNO = 33555186;
	  /** number: 755 type: long*/
	  public final static int EX_CACHE_TPRUCODE = 33555187;
	  /** number: 756 type: long*/
	  public final static int EX_CACHE_TIM = 33555188;
	  /** number: 757 type: long*/
	  public final static int EX_CACHE_TIMUSEC = 33555189;
	  /** number: 758 type: long*/
	  public final static int EX_CACHE_HITT = 33555190;
	  /** number: 759 type: long*/
	  public final static int EX_CACHE_HITTU = 33555191;
	  /** number: 760 type: short*/
	  public final static int EX_CACHE_NODEID = 760;
	  /** number: 761 type: char*/
	  public final static int EX_CACHE_CMD = 67109625;
	  /** number: 762 type: long*/
	  public final static int EX_CACHE_FLAGS = 33555194;
	  /** number: 763 type: long*/
	  public final static int EX_CACHE_HITS = 33555195;
	  /** number: 764 type: long*/
	  public final static int EX_CACHE_NRDEL = 33555196;
	  /** number: 765 type: long*/
	  public final static int EX_CACHE_NRDUPDEL = 33555197;
	  /** number: 767 type: long*/
	  public final static int EX_CACHE_BUFLEN = 33555199;
/* vim: set ts=4 sw=4 et smartindent: */
}
